//
// php-armadillo/base.hh
//
// @Author CismonX
//

#ifndef PHP_ARMA_BASE_HH
#define PHP_ARMA_BASE_HH

#include "php_arma.hh"

namespace php_arma
{
    template <typename T, typename ChildT>
    struct base
    {
        using native_t = typename ChildT::native_t;

        struct operators;

        zend_always_inline
        static int count_elements(zval *zv, zend_long *count)
        {
            *count = Z_NATIVE_OBJ_P(zv)->n_elem;
            return SUCCESS;
        }

        PHP_ARMA_COMMON_DECLARE();

    private:
        static PHP_FUNCTION(nElem);
        static PHP_FUNCTION(add);
        static PHP_FUNCTION(sub);
        static PHP_FUNCTION(neg);
        static PHP_FUNCTION(mul);
        static PHP_FUNCTION(dotMul);
        static PHP_FUNCTION(div);
        static PHP_FUNCTION(replace);
        static PHP_FUNCTION(transform);
        static PHP_FUNCTION(forEach);
        static PHP_FUNCTION(min);
        static PHP_FUNCTION(max);
        static PHP_FUNCTION(indexMin);
        static PHP_FUNCTION(indexMax);
        static PHP_FUNCTION(isEmpty);
        static PHP_FUNCTION(isFinite);
        static PHP_FUNCTION(hasInf);
        static PHP_FUNCTION(hasNan);
        static PHP_FUNCTION(print);
        static PHP_FUNCTION(rawPrint);
    };

    void base_init();
    
    constexpr const char base_php_name[] = "Base";

    inline zend_class_entry *base_ce;

    template <typename T, typename ChildT>
    struct base<T, ChildT>::operators
    {
        
    };
}

#endif // !PHP_ARMA_BASE_HH
